con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  RX_PIN        =  30
  TX_PIN        =  31
  MODE          = %0000                                 ' see FullDuplexSerial.spin for description
  BAUD          = 9600
  pin           = 15
  i2cSCL        = 18
  i2cSDA        = 29
  devSel        = $7000
    
obj
  com   :      "FullDuplexDebug"
  i2c      : "i2cObject"
var
  byte buffer[32]
  long eepromAddress 
pub Main  | i, c   
  com.start(TX_PIN,RX_PIN,%0000,9600)
  com.rx                            'input from VB app starts the sequence
  repeat i from $0 to $7FF0 step $20
    eepromAddress := i
    readit
    repeat c from 0 to 31
      com.tx(buffer[c])
   
  repeat  
PRI readIt
   if i2c.ReadPage(i2c#BootPin, i2c#EEPROM, eepromAddress, @buffer, 32)
     abort ' an error occurred during the read

PRI writeIt | startTime
   if i2c.WritePage(i2c#BootPin, i2c#EEPROM, eepromAddress, @buffer, 32)
     abort ' an error occured during the write
   startTime := cnt ' prepare to check for a timeout
   repeat while i2c.WriteWait(i2c#BootPin, i2c#EEPROM, eepromAddress)
     if cnt - startTime > clkfreq / 10
       abort ' waited more than a 1/10 second for the write to finish             